//robot.c

#include "robot.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

//Initialization for the robot.
//This initializes the robot in position (0,0)
//facing north (dir 1) and prints its position.

void initialize()
{
    dir = 1;
    row = 0;
    col = 0;
    printf("The robot is in position (0, 0) facing north\n");
}


//This function makes the robot turn right
//dir == 1 implies the robot is facing north
//2 is south,  3 is east , and 4 is west.
//So if the robot is currently facing north(1)
//after turn_right the robot will face
//east(3) and so on.

void turn_right()
{
  printf("The robot is in position (");
  printf("%d, %d", row , col); 

  if(dir == 1)
  {
    dir = 3;
    printf(") facing east.\n");
  }
  else if(dir == 2)
  {
    printf(") facing west.\n");
    dir = 4;
  }
  else if(dir == 3)
  {
    printf(") facing south.\n");
    dir = 2;
  }
  else if(dir == 4)
  {
    printf(") facing north.\n");
    dir = 1;
  }
}

//This function makes the robot turn left.
//If the robot is currently facing north(1)
//then after turn_left the robot will
//face west(4) and so on.

void turn_left(){
  printf("The robot is in position (");
  printf("%d, %d", row , col); 

  if(dir == 1){
    printf(") facing west.\n");
    dir = 4;
  }
  else if(dir == 2)
  {
    printf(") facing east.\n");
    dir = 3;
  }
  else if(dir == 3)
  {
    printf(") facing north.\n");
    dir = 1;
  }
  else if(dir == 4)
  {
    printf(") facing south.\n");
    dir = 2;
  }
}

//The function move makes the robot move one space 
//forward in the direction it is currently facing
//by either incrementing or decrementing the row
//or col.
//If the robot is at position (0,0) facing west(4)
//then after move the robot will be in position 
//(0,-1) facing west and so on.
//If the program has placed the robot in an out of
//bounds position then this function prints the
//list of signals caught during program run time
//and then terminates the program.
//
//PARAMETERS	loc	the list of signals caught during the main
//			program's run time

void move(char ** loc, int size)
{
  int i;
  printf("The robot is facing ");

  if(dir == 1)
  {
    row++;
    if(row > 3)
    {
      for (i = 0; i < size; i++)
        printf("%s\n", loc[i]);
      exit(0);
    }
    printf("north and is in position (%d, %d)\n", row, col);
  }
  else if(dir == 2)
  {
    row--;
    if(row < -3)
    {
      for (i = 0; i < size; i++)
        printf("%s\n", loc[i]);
      exit(0);
    }
    printf("south and is in position (%d, %d)\n", row, col);
  }
  else if(dir == 3)
  {
    col++;
    if(col > 3)
    {
      for (i = 0; i < size; i++)
        printf("%s\n", loc[i]);
      exit(0);
    }
    printf("east and is in position (%d, %d)\n", row, col);
  }
  else if(dir == 4)
  {
    col--;
    if(col < -3)
    {
      for (i = 0; i < size; i++)
        printf("%s\n", loc[i]);
      exit(0);
    }
    printf("west and is in position (%d, %d)\n", row, col);
  }
}
